## node-babel7 7.12.10+~cs150.141.83

=== Makefile ===
FLOW_COMMIT = a1f9a4c709dcebb27a5084acf47755fbae699c25
TEST262_COMMIT = d9740c172652d36194ceae3ed3d0484e9968ebc3
TYPESCRIPT_COMMIT = da8633212023517630de5f3620a23736b63234b1

FORCE_PUBLISH = -f @babel/runtime -f @babel/runtime-corejs2 -f @babel/runtime-corejs3 -f @babel/standalone

# Fix color output until TravisCI fixes https://github.com/travis-ci/travis-ci/issues/7967
export FORCE_COLOR = true

SOURCES = packages codemods eslint

COMMA := ,
EMPTY :=
SPACE := $(EMPTY) $(EMPTY)
COMMA_SEPARATED_SOURCES = $(subst $(SPACE),$(COMMA),$(SOURCES))

YARN := yarn
NODE := $(YARN) node


.PHONY: build build-dist watch lint fix clean test-clean test-only test test-ci publish bootstrap

build: build-bundle
ifneq ("$(BABEL_COVERAGE)", "true")
	$(MAKE) build-standalone
endif

build-bundle: clean clean-lib
	$(YARN) gulp build
	$(MAKE) generate-standalone generate-type-helpers
	# call build again as the generated files might need to be compiled again.
	$(YARN) gulp build
	$(MAKE) build-typings
	$(MAKE) build-dist

build-bundle-ci: bootstrap-only
	$(MAKE) build-bundle

generate-tsconfig:
	$(NODE) scripts/generators/tsconfig.js

generate-standalone:
	$(NODE) packages/babel-standalone/scripts/generate.js

generate-type-helpers:
	$(NODE) packages/babel-types/scripts/generateTypeHelpers.js

build-typings: build-flow-typings build-typescript-typings

build-flow-typings:
	$(NODE) packages/babel-types/scripts/generators/flow.js > packages/babel-types/lib/index.js.flow

build-typescript-typings:
	$(NODE) packages/babel-types/scripts/generators/typescript.js > packages/babel-types/lib/index.d.ts
	$(NODE) packages/babel-types/scripts/generators/typescript.js --ts3.7 > packages/babel-types/lib/index-ts3.7.d.ts

build-standalone: build-babel-standalone

build-standalone-ci: build-bundle-ci
	$(MAKE) build-standalone

build-babel-standalone:
	$(YARN) gulp build-babel-standalone

prepublish-build-standalone:
	BABEL_ENV=production IS_PUBLISH=true $(YARN) gulp build-babel-standalone

build-dist: build-polyfill-dist build-plugin-transform-runtime-dist

build-polyfill-dist:
	cd packages/babel-polyfill; \
	scripts/build-dist.sh

build-plugin-transform-runtime-dist:
	cd packages/babel-plugin-transform-runtime; \
	$(NODE) scripts/build-dist.js

build-no-bundle: clean clean-lib
	BABEL_ENV=development $(YARN) gulp build-no-bundle
	# Ensure that build artifacts for types are created during local
	# development too.
	# Babel-transform-fixture-test-runner requires minified polyfill for performance
	$(MAKE) generate-type-helpers build-typings build-polyfill-dist

watch: build-no-bundle
	BABEL_ENV=development $(YARN) gulp watch

flowcheck-ci:
	$(MAKE) flow

code-quality: tscheck flow lint

tscheck: generate-tsconfig
	make build-typescript-typings
	$(YARN) tsc -b .

flow:
	$(YARN) flow check --strip-root

lint-ci: lint-js-ci lint-ts-ci check-compat-data-ci

lint-js-ci:
	$(MAKE) lint-js

lint-ts-ci:
	$(MAKE) lint-ts

check-compat-data-ci:
	$(MAKE) check-compat-data

lint: lint-js lint-ts

lint-js:
	BABEL_ENV=test $(YARN) eslint scripts $(SOURCES) '*.{js,ts}' --format=codeframe --ext .js,.cjs,.mjs,.ts

lint-ts:
	scripts/lint-ts-typings.sh

fix: fix-json fix-js

fix-js:
	$(YARN) eslint scripts $(SOURCES) '*.{js,ts}' --format=codeframe --ext .js,.cjs,.mjs,.ts --fix

fix-json:
	$(YARN) prettier "{$(COMMA_SEPARATED_SOURCES)}/*/test/fixtures/**/options.json" --write --loglevel warn

check-compat-data:
	cd packages/babel-compat-data; CHECK_COMPAT_DATA=true $(YARN) run build-data

build-compat-data:
	cd packages/babel-compat-data; $(YARN) run build-data

clean: test-clean
	rm -f .npmrc
	rm -rf packages/babel-polyfill/browser*
	rm -rf packages/babel-polyfill/dist
	rm -rf coverage
	rm -rf packages/*/npm-debug*
	rm -rf node_modules/.cache

clean-tsconfig:
	rm -f tsconfig.json
	git clean packages/*/tsconfig.json -xfq
	git clean codemods/*/tsconfig.json -xfq
	git clean eslint/*/tsconfig.json -xfq
	rm -f */*/tsconfig.tsbuildinfo

test-clean:
	$(foreach source, $(SOURCES), \
		$(call clean-source-test, $(source)))

# Does not work on Windows; use "$(YARN) jest" instead
test-only:
	BABEL_ENV=test ./scripts/test.sh
	$(MAKE) test-clean

test: lint test-only

test-ci: build-standalone-ci
	BABEL_ENV=test $(YARN) jest --maxWorkers=4 --ci
	$(MAKE) test-clean

# Does not work on Windows
test-ci-coverage: SHELL:=/bin/bash
test-ci-coverage:
	BABEL_COVERAGE=true BABEL_ENV=test $(MAKE) bootstrap
	BABEL_ENV=test TEST_TYPE=cov ./scripts/test-cov.sh

bootstrap-flow:
	rm -rf build/flow
	mkdir -p build
	git clone --single-branch --shallow-since=2018-11-01 https://github.com/facebook/flow.git build/flow
	cd build/flow && git checkout -q $(FLOW_COMMIT)

test-flow:
	$(NODE) scripts/parser-tests/flow

test-flow-update-allowlist:
	$(NODE) scripts/parser-tests/flow --update-allowlist

bootstrap-typescript:
	rm -rf ./build/typescript
	mkdir -p ./build
	git clone --single-branch --shallow-since=2019-09-01 https://github.com/microsoft/TypeScript.git ./build/typescript
	cd build/typescript && git checkout -q $(TYPESCRIPT_COMMIT)

test-typescript:
	$(NODE) scripts/parser-tests/typescript

test-typescript-update-allowlist:
	$(NODE) scripts/parser-tests/typescript --update-allowlist

bootstrap-test262:
	rm -rf build/test262
	mkdir -p build
	git clone --single-branch --shallow-since=2019-12-01 https://github.com/tc39/test262.git build/test262
	cd build/test262 && git checkout -q $(TEST262_COMMIT)

test-test262:
	$(NODE) scripts/parser-tests/test262

test-test262-update-allowlist:
	$(NODE) scripts/parser-tests/test262 --update-allowlist

# Does not work on Windows
clone-license:
	./scripts/clone-license.sh

prepublish-build: clean-lib clean-runtime-helpers
	NODE_ENV=production BABEL_ENV=production STRIP_BABEL_8_FLAG=true $(MAKE) build-bundle
	$(MAKE) prepublish-build-standalone clone-license

prepublish:
	$(MAKE) check-yarn-bug-1882
	$(MAKE) bootstrap-only
	$(MAKE) prepublish-build
	IS_PUBLISH=true $(MAKE) test
	# We don't want to publish TS-related files yet, except for @babel/types
	rm -f packages/*/lib/**/*.d.ts{,.map}
	rm -f codemods/*/lib/**/*.d.ts{,.map}
	rm -f eslint/*/lib/**/*.d.ts{,.map}
	$(MAKE) clean-tsconfig
	$(MAKE) build-typescript-typings

new-version:
	git pull --rebase
	$(YARN) release-tool version $(FORCE_PUBLISH)

# NOTE: Run make new-version first
publish:
	@echo "Please confirm you have stopped make watch. (y)es, [N]o:"; \
	read CLEAR; \
	if [ "_$$CLEAR" != "_y" ]; then \
		exit 1; \
	fi
	$(MAKE) prepublish
	$(YARN) release-tool publish
	$(MAKE) clean

check-yarn-bug-1882:
ifneq ("$(shell grep 3155328e5 .yarn/releases/yarn-*.cjs -c)", "0")
	@echo "Your version of yarn is affected by https://github.com/yarnpkg/berry/issues/1882"
	@echo "Please run \`sed -i -e "s/3155328e5/4567890e5/g" .yarn/releases/yarn-*.cjs\`"
	@exit 1
endif

publish-ci: prepublish
ifneq ("$(NPM_TOKEN)", "")
	echo "//registry.npmjs.org/:_authToken=${NPM_TOKEN}" > .npmrc
else
	echo "Missing NPM_TOKEN env var"
	exit 1
endif
	$(YARN) release-tool publish --yes
	rm -f .npmrc
	$(MAKE) clean

publish-test:
ifneq ("$(I_AM_USING_VERDACCIO)", "I_AM_SURE")
	echo "You probably don't know what you are doing"
	exit 1
endif
	$(MAKE) check-yarn-bug-1882
	$(YARN) release-tool version $(VERSION) --all --yes --tag-version-prefix="version-e2e-test-"
	$(MAKE) prepublish-build
	YARN_NPM_PUBLISH_REGISTRY=http://localhost:4873 $(YARN) release-tool publish --yes --tag-version-prefix="version-e2e-test-"
	$(MAKE) clean

bootstrap-only: clean-all
	yarn install

bootstrap: bootstrap-only generate-tsconfig
	$(MAKE) build

clean-lib:
	$(foreach source, $(SOURCES), \
		$(call clean-source-lib, $(source)))

clean-runtime-helpers:
	rm -f packages/babel-runtime/helpers/**/*.js
	rm -f packages/babel-runtime-corejs2/helpers/**/*.js
	rm -f packages/babel-runtime-corejs3/helpers/**/*.js
	rm -rf packages/babel-runtime-corejs2/core-js

clean-all: clean-tsconfig
	rm -rf node_modules
	rm -rf package-lock.json
	rm -rf .changelog

	$(foreach source, $(SOURCES), \
		$(call clean-source-all, $(source)))

	$(MAKE) clean

update-env-corejs-fixture:
	rm -rf packages/babel-preset-env/node_modules/core-js-compat
	$(YARN)
	$(MAKE) build-bundle
	OVERWRITE=true $(YARN) jest packages/babel-preset-env

define clean-source-lib
	rm -rf $(1)/*/lib

endef

define clean-source-test
	rm -rf $(1)/*/test/tmp
	rm -rf $(1)/*/test-fixtures.json

endef

define clean-source-all
	$(call clean-source-lib, $1)
	rm -rf $(1)/*/node_modules
	rm -rf $(1)/*/package-lock.json

endef

=== debian/changelog ===
node-babel7 (7.12.10+~cs150.141.83-1) unstable; urgency=medium

  * Team upload
  * Add ctype=nodejs to component(s)
  * New upstream version 7.12.10+~cs150.141.83
  * Refresh patches
  * Improve patch load-plugins-from-system-libraries

 -- Xavier Guimard <yadd@debian.org>  Sat, 12 Dec 2020 17:17:39 +0100

=== debian/control ===
Source: node-babel7
Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
Uploaders: Pirate Praveen <praveen@debian.org>
Section: javascript
#Testsuite: autopkgtest-pkg-nodejs
Priority: optional
Build-Depends: debhelper-compat (= 13)
 , gulp (>= 4)
 , node-babel7 (>= 7.9.6) <!pkg.node-babel7.npm>
 , node-browserslist (>= 4.6~)
 , node-chalk
 , node-clean-css
 , node-commander (>= 4.1.1)
 , node-core-js (>= 3.1.1~)
 , node-css-select
 , node-css-selector-tokenizer
 , node-debbundle-acorn
 , node-debug
 , node-globals
 , node-gulp-babel (>= 8.0~)
 , node-gulp-newer
 , node-gulp-plumber
 , node-gulp-rename
 , node-gulp-util
 , node-he
 , node-htmlparser2
 , node-invariant
 , node-leven (>= 3.1.0+~cs1.1.1)
 , node-liftoff (>= 3.1.0-4~)
 , node-lodash (>= 4.17.19+dfsg1~)
 , node-merge-stream
 , node-multimatch
 , node-output-file-sync
 , node-recast
 , node-regenerator-transform (>= 0.14~)
 , node-rimraf
 , node-rollup-plugin-babel (>= 5.2.0)
 , node-rollup-plugin-commonjs (>= 13.0.0)
 , node-rollup-plugin-json (>= 4.1.0)
 , node-rollup-plugin-node-resolve (>= 9.0.0)
 , node-rollup-plugin-replace (>= 2.3.3)
 , node-semver
# for debian/build_modules/webpack-stream
 , node-supports-color (>= 5.3~)
 , node-through
 , node-through2
 , node-to-fast-properties
 , node-vinyl-fs (>= 2.4.4-2~)
 , yarnpkg <pkg.node-babel7.yarnpkg>
 , git <pkg.node-babel7.yarnpkg>
 , dh-sequence-nodejs
 , rollup
 , uglifyjs
 , webpack
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/js-team/node-babel
Vcs-Git: https://salsa.debian.org/js-team/node-babel.git
Homepage: https://babeljs.io/
Rules-Requires-Root: no

Package: node-babel7
Architecture: all
Depends: ${misc:Depends}
 , node-browserslist (>= 4.6~)
 , node-chalk
 , node-commander (>= 4.1.1)
 , node-convert-source-map
 , node-core-js (>= 3.1.1~)
 , node-debug
 , node-esutils
 , node-find-cache-dir
 , node-fs-readdir-recursive (>= 1.1.0~)
 , node-glob
 , node-globals
 , node-js-tokens
 , node-jsesc
 , node-json5
 , node-lodash (>= 4.17.19+dfsg1~)
 , node-make-dir
 , node-quick-lru
 , node-regenerator-runtime
 , node-regenerator-transform (>= 0.14~)
 , node-regexpu-core
 , node-resolve
 , node-semver
 , node-slash
 , node-source-map
 , node-source-map-support
 , node-to-fast-properties
 , node-v8flags
 , nodejs
Breaks: node-babel-core (<< 6.26.0+repack-3~)
Provides: ${nodejs:Provides}, babeljs
Description: Babel command line
 Babel is a JavaScript compiler to use next generation JavaScript, today.
 .
 ES2015 and beyond: Babel has support for the latest version of JavaScript
 through syntax transformers. These plugins allow you to use new syntax, right
 now without waiting for browser support.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

GULP=/usr/bin/gulp

%:
	dh $@

override_dh_auto_build:
ifeq (,$(filter pkg.node-babel7.yarnpkg,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	rm -f node_modules/@babel/code-frame
	cd babel-plugin-dynamic-import-node && babeljs-7 src --out-dir lib
	make build build-dist
	cd charcodes; \
	for D in ./packages/*; do \
		mkdir "$$D/lib"; \
		babeljs-7 "$$D/src/index.js" -o "$$D/lib/index.js" --env-name "cjs"; \
		babeljs-7 "$$D/src/index.js" -o "$$D/lib/index.mjs" --env-name "esm"; \
	done
	rm -rf node_modules
	cd pirates && sh -ex ../debian/nodejs/pirates/build
else
	rm -rf node_modules
	HOME=`pwd` yarnpkg install
	make build build-dist
	cd babel-plugin-dynamic-import-node && HOME=`pwd` yarnpkg install && yarnpkg build
	cd charcodes && HOME=`pwd` yarnpkg install && ./scripts/build.sh
	cd pirates && HOME=`pwd` yarnpkg install && yarnpkg build
endif

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
override_dh_auto_test:
endif

override_dh_install:
	dh_install
	find debian -name .npmignore -delete
	find debian -name .gitignore -delete

override_dh_fixperms:
	dh_fixperms
	chmod +x debian/node-babel7/usr/share/nodejs/@babel/cli/bin/babel-external-helpers.js \
		debian/node-babel7/usr/share/nodejs/@babel/cli/bin/babel.js \
		debian/node-babel7/usr/share/nodejs/@babel/node/bin/babel-node.js \
		debian/node-babel7/usr/share/nodejs/@babel/parser/bin/babel-parser.js

=== debian/watch ===
version=4
opts=\
repacksuffix=+dfsg,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$//,\
filenamemangle=s/.*\/v?([\d\.-]+)\.tar\.gz/node-babel7-$1.tar.gz/ \
 https://github.com/babel/babel/tags .*/archive/v?([\d\.]+).tar.gz group

opts=\
ctype=nodejs,\
component=charcodes,\
dversionmangle=auto,\
filenamemangle=s/.*\/v?([\d\.-]+)\.tar\.gz/node-charcodes-$1.tar.gz/ \
 https://github.com/xtuc/charcodes/tags .*/archive/v?([\d\.]+).tar.gz checksum

opts=\
ctype=nodejs,\
component=pirates,\
dversionmangle=auto,\
filenamemangle=s/.*\/v?([\d\.-]+)\.tar\.gz/node-pirates-$1.tar.gz/ \
 https://github.com/ariporad/pirates/tags .*/archive/v?([\d\.]+).tar.gz checksum

opts=\
ctype=nodejs,\
component=node-modules-regexp,\
dversionmangle=auto,\
filenamemangle=s/.*\/v?([\d\.-]+)\.tar\.gz/node-node-modules-regexp-$1.tar.gz/ \
 https://github.com/jamestalmage/node-modules-regexp/tags .*/archive/v?([\d\.]+).tar.gz checksum

opts=\
ctype=nodejs,\
component=js-levenshtein,\
dversionmangle=auto,\
filenamemangle=s/.*\/v?([\d\.-]+)\.tar\.gz/node-js-levenshtein-$1.tar.gz/ \
 https://github.com/gustf/js-levenshtein/tags?after=1.1.6 .*/archive/v?(1(?:.[\d\.]+)?).tar.gz checksum

# It is not recommended use npmregistry. Please investigate more.
# Take a look at https://wiki.debian.org/debian/watch/
opts="searchmode=plain,ctype=nodejs,component=babelpreset-modules,pgpmode=none" \
 https://registry.npmjs.org/@babel/preset-modules https://registry.npmjs.org/@babel/preset-modules/-/preset-modules-([\d\.]+)@ARCHIVE_EXT@ checksum

opts=\
ctype=nodejs,\
component=babel-plugin-dynamic-import-node,\
dversionmangle=auto,\
filenamemangle=s/.*\/v?([\d\.-]+)\.tar\.gz/node-babel-plugin-dynamic-import-node-$1.tar.gz/ \
 https://github.com/airbnb/babel-plugin-dynamic-import-node/tags .*/archive/v?([\d\.]+).tar.gz checksum

# It is not recommended use npmregistry. Please investigate more.
# Take a look at https://wiki.debian.org/debian/watch/
opts="searchmode=plain,ctype=nodejs,component=gensync,pgpmode=none,uversionmangle=s/-beta.*//" \
 https://registry.npmjs.org/gensync https://registry.npmjs.org/gensync/-/gensync-([\w\.\-]+)@ARCHIVE_EXT@ checksum

# It is not recommended use npmregistry. Please investigate more.
# Take a look at https://wiki.debian.org/debian/watch/
opts="searchmode=plain,ctype=nodejs,component=babelplugin-syntax-export-namespace-from,pgpmode=none" \
 https://registry.npmjs.org/@babel/plugin-syntax-export-namespace-from https://registry.npmjs.org/@babel/plugin-syntax-export-namespace-from/-/plugin-syntax-export-namespace-from-([\d\.]+)@ARCHIVE_EXT@ checksum

# It is not recommended use npmregistry. Please investigate more.
# Take a look at https://wiki.debian.org/debian/watch/
opts="searchmode=plain,ctype=nodejs,component=babelplugin-syntax-object-rest-spread,pgpmode=none" \

## node-babel7 7.12.11+~cs150.141.84

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 FLOW_COMMIT = a1f9a4c709dcebb27a5084acf47755fbae699c25
-TEST262_COMMIT = d9740c172652d36194ceae3ed3d0484e9968ebc3
+TEST262_COMMIT = 36d2d2d348d83e9d6554af59a672fbcd9413914b
 TYPESCRIPT_COMMIT = da8633212023517630de5f3620a23736b63234b1
 
 FORCE_PUBLISH = -f @babel/runtime -f @babel/runtime-corejs2 -f @babel/runtime-corejs3 -f @babel/standalone
@@ -27,10 +27,7 @@
 
 build-bundle: clean clean-lib
 	$(YARN) gulp build
-	$(MAKE) generate-standalone generate-type-helpers
-	# call build again as the generated files might need to be compiled again.
-	$(YARN) gulp build
-	$(MAKE) build-typings
+	$(MAKE) build-flow-typings
 	$(MAKE) build-dist
 
 build-bundle-ci: bootstrap-only
@@ -39,20 +36,14 @@
 generate-tsconfig:
 	$(NODE) scripts/generators/tsconfig.js
 
-generate-standalone:
-	$(NODE) packages/babel-standalone/scripts/generate.js
-
 generate-type-helpers:
-	$(NODE) packages/babel-types/scripts/generateTypeHelpers.js
-
-build-typings: build-flow-typings build-typescript-typings
+	$(YARN) gulp generate-type-helpers
 
 build-flow-typings:
 	$(NODE) packages/babel-types/scripts/generators/flow.js > packages/babel-types/lib/index.js.flow
 
-build-typescript-typings:
-	$(NODE) packages/babel-types/scripts/generators/typescript.js > packages/babel-types/lib/index.d.ts
-	$(NODE) packages/babel-types/scripts/generators/typescript.js --ts3.7 > packages/babel-types/lib/index-ts3.7.d.ts
+build-typescript-3.7-typings:
+	$(NODE) packages/babel-types/scripts/generators/typescript-3.7.js > packages/babel-types/lib/index-ts3.7.d.ts
 
 build-standalone: build-babel-standalone
 
@@ -76,11 +67,11 @@
 	$(NODE) scripts/build-dist.js
 
 build-no-bundle: clean clean-lib
-	BABEL_ENV=development $(YARN) gulp build-no-bundle
+	BABEL_ENV=development $(YARN) gulp build-dev
 	# Ensure that build artifacts for types are created during local
 	# development too.
 	# Babel-transform-fixture-test-runner requires minified polyfill for performance
-	$(MAKE) generate-type-helpers build-typings build-polyfill-dist
+	$(MAKE) build-flow-typings build-polyfill-dist
 
 watch: build-no-bundle
 	BABEL_ENV=development $(YARN) gulp watch
@@ -91,30 +82,18 @@
 code-quality: tscheck flow lint
 
 tscheck: generate-tsconfig
-	make build-typescript-typings
 	$(YARN) tsc -b .
 
-flow:
+flow: build-flow-typings
 	$(YARN) flow check --strip-root
 
-lint-ci: lint-js-ci lint-ts-ci check-compat-data-ci
-
-lint-js-ci:
-	$(MAKE) lint-js
-
-lint-ts-ci:
-	$(MAKE) lint-ts
+lint-ci: lint check-compat-data-ci
 
 check-compat-data-ci:
 	$(MAKE) check-compat-data
 
-lint: lint-js lint-ts
-
-lint-js:
+lint:
 	BABEL_ENV=test $(YARN) eslint scripts $(SOURCES) '*.{js,ts}' --format=codeframe --ext .js,.cjs,.mjs,.ts
-
-lint-ts:
-	scripts/lint-ts-typings.sh
 
 fix: fix-json fix-js
 
@@ -208,19 +187,21 @@
 
 prepublish-build: clean-lib clean-runtime-helpers
 	NODE_ENV=production BABEL_ENV=production STRIP_BABEL_8_FLAG=true $(MAKE) build-bundle
-	$(MAKE) prepublish-build-standalone clone-license
+	$(MAKE) prepublish-build-standalone clone-license prepublish-prepare-dts
+
+prepublish-prepare-dts:
+	$(MAKE) clean-tsconfig
+	$(MAKE) tscheck
+	$(YARN) gulp bundle-dts
+	$(YARN) gulp clean-dts
+	$(MAKE) build-typescript-3.7-typings
+	$(MAKE) clean-tsconfig
 
 prepublish:
 	$(MAKE) check-yarn-bug-1882
 	$(MAKE) bootstrap-only
 	$(MAKE) prepublish-build
 	IS_PUBLISH=true $(MAKE) test
-	# We don't want to publish TS-related files yet, except for @babel/types
-	rm -f packages/*/lib/**/*.d.ts{,.map}
-	rm -f codemods/*/lib/**/*.d.ts{,.map}
-	rm -f eslint/*/lib/**/*.d.ts{,.map}
-	$(MAKE) clean-tsconfig
-	$(MAKE) build-typescript-typings
 
 new-version:
 	git pull --rebase

=== debian/changelog ===
node-babel7 (7.12.11+~cs150.141.84-3) unstable; urgency=medium

  * Team upload
  * Build typescript definitions (Closes: #978341)

 -- Xavier Guimard <yadd@debian.org>  Sun, 03 Jan 2021 18:08:42 +0100

node-babel7 (7.12.11+~cs150.141.84-2) unstable; urgency=medium

  * Team upload
  * Require pkg-js-tools ≥ 0.9.58~ (Closes: #977677)

 -- Xavier Guimard <yadd@debian.org>  Fri, 18 Dec 2020 22:34:20 +0100

node-babel7 (7.12.11+~cs150.141.84-1) unstable; urgency=medium

  * Team upload
  * New upstream version 7.12.11+~cs150.141.84
  * Refresh patches
  * Embed rollup-plugin-dts in build only modules
  * Add build dependency to node-typescript
  * Update lintian overrides

 -- Xavier Guimard <yadd@debian.org>  Thu, 17 Dec 2020 12:27:51 +0100

node-babel7 (7.12.10+~cs150.141.83-3) unstable; urgency=medium

  * Team upload
  * Install /usr/bin/babeljs-parser
  * Build manpages using help2man
  * Remove useless dependency to node-environment-flags (Closes: #977232)

 -- Xavier Guimard <yadd@debian.org>  Thu, 17 Dec 2020 08:46:12 +0100

node-babel7 (7.12.10+~cs150.141.83-2) unstable; urgency=medium

  * Team upload
  * Remove some build modules, and add build dependencies to:
    + node-cheerio
    + node-jest-worker
    + node-jsdom
    + node-make-error
    + node-rollup-plugin-inject
    + node-rollup-plugin-node-polyfills
    + node-rollup-plugin-terser
    + node-serialize-javascript
  * Build @babel/standalone (Closes: #977485)

 -- Xavier Guimard <yadd@debian.org>  Thu, 17 Dec 2020 03:53:31 +0100

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,14 @@
 #Testsuite: autopkgtest-pkg-nodejs
 Priority: optional
 Build-Depends: debhelper-compat (= 13)
+ , dh-sequence-nodejs (>= 0.9.58~)
  , gulp (>= 4)
+ , help2man
+ , jq
  , node-babel7 (>= 7.9.6) <!pkg.node-babel7.npm>
  , node-browserslist (>= 4.6~)
  , node-chalk
+ , node-cheerio
  , node-clean-css
  , node-commander (>= 4.1.1)
  , node-core-js (>= 3.1.1~)
@@ -25,9 +29,13 @@
  , node-he
  , node-htmlparser2
  , node-invariant
+ , node-is-windows
+ , node-jest-worker
+ , node-jsdom
  , node-leven (>= 3.1.0+~cs1.1.1)
  , node-liftoff (>= 3.1.0-4~)
  , node-lodash (>= 4.17.19+dfsg1~)
+ , node-make-error
  , node-merge-stream
  , node-multimatch
  , node-output-file-sync
@@ -36,19 +44,24 @@
  , node-rimraf
  , node-rollup-plugin-babel (>= 5.2.0)
  , node-rollup-plugin-commonjs (>= 13.0.0)
+ , node-rollup-plugin-inject
  , node-rollup-plugin-json (>= 4.1.0)
  , node-rollup-plugin-node-resolve (>= 9.0.0)
+ , node-rollup-plugin-node-polyfills
  , node-rollup-plugin-replace (>= 2.3.3)
+ , node-rollup-plugin-terser
  , node-semver
+ , node-serialize-javascript
 # for debian/build_modules/webpack-stream
  , node-supports-color (>= 5.3~)
  , node-through
  , node-through2
  , node-to-fast-properties
+ , node-typescript
+ , node-typescript-types
  , node-vinyl-fs (>= 2.4.4-2~)
  , yarnpkg <pkg.node-babel7.yarnpkg>
  , git <pkg.node-babel7.yarnpkg>
- , dh-sequence-nodejs
  , rollup
  , uglifyjs
  , webpack

=== debian/rules ===
--- 
+++ 
@@ -4,24 +4,68 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
+include /usr/share/dpkg/pkg-info.mk
+
 GULP=/usr/bin/gulp
+BABELJSDESC="The compiler for writing next generation JavaScript"
+BABELJSNODEDESC="CLI that works exactly the same as the Node.js CLI, with the added benefit of compiling with Babel presets and plugins before running it"
+EXTMODULES=$(shell perl -lne 'print $$1 if/component=([^,]*)/' debian/watch)
 
 %:
 	dh $@
 
 override_dh_auto_build:
 ifeq (,$(filter pkg.node-babel7.yarnpkg,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
-	rm -f node_modules/@babel/code-frame
+	#rm -f node_modules/@babel/code-frame
+	#rm -f node_modules/@babel/preset-modules
+	mv node_modules/@babel node_modules/.babel
+	mkdir node_modules/@babel
+	# Build @babel/plugin-dynamic-import-node
 	cd babel-plugin-dynamic-import-node && babeljs-7 src --out-dir lib
-	make build build-dist
+	# Build @babel/preset-modules
+	cd babelpreset-modules && babeljs src --presets '@babel/preset-env' -d lib --ignore '**/*.test.js'
+	# Build charcodes
 	cd charcodes; \
 	for D in ./packages/*; do \
 		mkdir "$$D/lib"; \
 		babeljs-7 "$$D/src/index.js" -o "$$D/lib/index.js" --env-name "cjs"; \
 		babeljs-7 "$$D/src/index.js" -o "$$D/lib/index.mjs" --env-name "esm"; \
 	done
-	rm -rf node_modules
+	# Build babel except standalone
+	set -e; for i in $(EXTMODULES); do \
+		NAME=`jq -r .name $$i/package.json`; \
+		if test "$$NAME" != "null"; then \
+			rm -rf node_modules/$$NAME; \
+			mv $$i node_modules/$$NAME; \
+			echo mv node_modules/$$NAME $$i >> debian/restore.sh; \
+		fi; \
+	done
+	if [ -e charcodes ]; then \
+		mv charcodes node_modules/.charcodes; \
+		for i in `ls node_modules/.charcodes/packages/`; do \
+			ln -vs .charcodes/packages/$$i node_modules/$$i; \
+		done; \
+		echo mv node_modules/.charcodes charcodes >> debian/restore.sh; \
+	fi
+	make build YARN=''
+	#mv node_modules/.babel/* node_modules/@babel/
+	for i in `ls packages/`; do \
+		NAME=`jq -r .name packages/$$i/package.json`; \
+		if [ -e node_modules/$$NAME ]; then \
+			echo -n ''; \
+		else \
+			ln -s ../../packages/$$i node_modules/$$NAME; \
+		fi; \
+	done
+	make tscheck YARN=''
+	gulp bundle-dts
+	make build-typescript-3.7-typings
+	sh -e debian/restore.sh
+	rm -f debian/restore.sh
+	# Build pirates
+	mv node_modules tmp_modules
 	cd pirates && sh -ex ../debian/nodejs/pirates/build
+	mv tmp_modules node_modules
 else
 	rm -rf node_modules
 	HOME=`pwd` yarnpkg install
@@ -30,6 +74,14 @@
 	cd charcodes && HOME=`pwd` yarnpkg install && ./scripts/build.sh
 	cd pirates && HOME=`pwd` yarnpkg install && yarnpkg build
 endif
+	help2man --no-info \
+		--version-string $(DEB_VERSION_UPSTREAM) \
+		-n $(BABELJSDESC) \
+		packages/babel-cli/bin/babel.js > babeljs-7.1
+	help2man --no-info \
+		--version-string $(DEB_VERSION_UPSTREAM) \
+		-n $(BABELJSNODEDESC) \
+		packages/babel-node/bin/babel-node.js > babeljs-7-node.1
 
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
 override_dh_auto_test:

## node-babel7 7.12.12+~cs150.141.84

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,6 @@
 FLOW_COMMIT = a1f9a4c709dcebb27a5084acf47755fbae699c25
-TEST262_COMMIT = 36d2d2d348d83e9d6554af59a672fbcd9413914b
+TEST262_COMMIT = b2e9dff2816cceb5ee84c0c226c50a31d01a7297
 TYPESCRIPT_COMMIT = da8633212023517630de5f3620a23736b63234b1
-
-FORCE_PUBLISH = -f @babel/runtime -f @babel/runtime-corejs2 -f @babel/runtime-corejs3 -f @babel/standalone
 
 # Fix color output until TravisCI fixes https://github.com/travis-ci/travis-ci/issues/7967
 export FORCE_COLOR = true
@@ -42,8 +40,9 @@
 build-flow-typings:
 	$(NODE) packages/babel-types/scripts/generators/flow.js > packages/babel-types/lib/index.js.flow
 
-build-typescript-3.7-typings:
-	$(NODE) packages/babel-types/scripts/generators/typescript-3.7.js > packages/babel-types/lib/index-ts3.7.d.ts
+# For TypeScript older than 3.7
+build-typescript-legacy-typings:
+	$(NODE) packages/babel-types/scripts/generators/typescript-legacy.js > packages/babel-types/lib/index-legacy.d.ts
 
 build-standalone: build-babel-standalone
 
@@ -56,11 +55,7 @@
 prepublish-build-standalone:
 	BABEL_ENV=production IS_PUBLISH=true $(YARN) gulp build-babel-standalone
 
-build-dist: build-polyfill-dist build-plugin-transform-runtime-dist
-
-build-polyfill-dist:
-	cd packages/babel-polyfill; \
-	scripts/build-dist.sh
+build-dist: build-plugin-transform-runtime-dist
 
 build-plugin-transform-runtime-dist:
 	cd packages/babel-plugin-transform-runtime; \
@@ -70,8 +65,7 @@
 	BABEL_ENV=development $(YARN) gulp build-dev
 	# Ensure that build artifacts for types are created during local
 	# development too.
-	# Babel-transform-fixture-test-runner requires minified polyfill for performance
-	$(MAKE) build-flow-typings build-polyfill-dist
+	$(MAKE) build-flow-typings
 
 watch: build-no-bundle
 	BABEL_ENV=development $(YARN) gulp watch
@@ -111,8 +105,6 @@
 
 clean: test-clean
 	rm -f .npmrc
-	rm -rf packages/babel-polyfill/browser*
-	rm -rf packages/babel-polyfill/dist
 	rm -rf coverage
 	rm -rf packages/*/npm-debug*
 	rm -rf node_modules/.cache
@@ -194,7 +186,7 @@
 	$(MAKE) tscheck
 	$(YARN) gulp bundle-dts
 	$(YARN) gulp clean-dts
-	$(MAKE) build-typescript-3.7-typings
+	$(MAKE) build-typescript-legacy-typings
 	$(MAKE) clean-tsconfig
 
 prepublish:
@@ -205,7 +197,7 @@
 
 new-version:
 	git pull --rebase
-	$(YARN) release-tool version $(FORCE_PUBLISH)
+	$(YARN) release-tool version -f @babel/standalone
 
 # NOTE: Run make new-version first
 publish:
@@ -225,17 +217,6 @@
 	@exit 1
 endif
 
-publish-ci: prepublish
-ifneq ("$(NPM_TOKEN)", "")
-	echo "//registry.npmjs.org/:_authToken=${NPM_TOKEN}" > .npmrc
-else
-	echo "Missing NPM_TOKEN env var"
-	exit 1
-endif
-	$(YARN) release-tool publish --yes
-	rm -f .npmrc
-	$(MAKE) clean
-
 publish-test:
 ifneq ("$(I_AM_USING_VERDACCIO)", "I_AM_SURE")
 	echo "You probably don't know what you are doing"

=== debian/changelog ===
node-babel7 (7.12.12+~cs150.141.84-6+deb11u1) bullseye-security; urgency=medium

  * Only evaluate own String/Number/Math methods (Closes: #1053880, CVE-2023-45133)

 -- Yadd <yadd@debian.org>  Fri, 13 Oct 2023 18:25:57 +0400

node-babel7 (7.12.12+~cs150.141.84-6) unstable; urgency=medium

  * Team upload
  * Make build reproducible

 -- Xavier Guimard <yadd@debian.org>  Wed, 03 Feb 2021 06:31:56 +0100

node-babel7 (7.12.12+~cs150.141.84-5) unstable; urgency=medium

  * Team upload
  * Remove tsconfig.buildinfo files (makes build reproducible)

 -- Xavier Guimard <yadd@debian.org>  Mon, 01 Feb 2021 16:33:41 +0100

node-babel7 (7.12.12+~cs150.141.84-4) unstable; urgency=medium

  * Team upload

  [ Pirate Praveen ]
  * Update minimum versions of dependencies

  [ Xavier Guimard ]
  * Install manpages without alternatives (Closes: #979551)

 -- Xavier Guimard <yadd@debian.org>  Wed, 27 Jan 2021 22:47:58 +0100

node-babel7 (7.12.12+~cs150.141.84-3) unstable; urgency=medium

  * Team upload
  * Remove useless build dependency to node-typescript-types (Closes: #979788)

 -- Xavier Guimard <yadd@debian.org>  Fri, 22 Jan 2021 19:07:09 +0100

node-babel7 (7.12.12+~cs150.141.84-2) unstable; urgency=medium

  * Team upload
  * Source-only upload

 -- Xavier Guimard <yadd@debian.org>  Sat, 09 Jan 2021 07:39:08 +0100

node-babel7 (7.12.12+~cs150.141.84-1) unstable; urgency=medium

  * Team upload
  * New upstream version 7.12.12+~cs150.141.84
  * Build a really "standalone" @babel/standalone
  * Refresh patches
  * Provides separated node-babel7-runtime and node-babel7-standalone
  * Update lintian overrides

 -- Xavier Guimard <yadd@debian.org>  Tue, 05 Jan 2021 13:28:05 +0100

=== debian/rules ===
--- 
+++ 
@@ -18,12 +18,15 @@
 ifeq (,$(filter pkg.node-babel7.yarnpkg,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
 	#rm -f node_modules/@babel/code-frame
 	#rm -f node_modules/@babel/preset-modules
+	cp -a /usr/share/nodejs/@types/node ./node_modules/@types
 	mv node_modules/@babel node_modules/.babel
 	mkdir node_modules/@babel
+	ln -s /usr/share/nodejs/@babel/runtime node_modules/@babel/
+	ln -s /usr/share/nodejs/@babel/compat-data node_modules/@babel/
 	# Build @babel/plugin-dynamic-import-node
 	cd babel-plugin-dynamic-import-node && babeljs-7 src --out-dir lib
 	# Build @babel/preset-modules
-	cd babelpreset-modules && babeljs src --presets '@babel/preset-env' -d lib --ignore '**/*.test.js'
+	cd babel-preset-modules && babeljs src --presets '@babel/preset-env' -d lib --ignore '**/*.test.js'
 	# Build charcodes
 	cd charcodes; \
 	for D in ./packages/*; do \
@@ -59,7 +62,7 @@
 	done
 	make tscheck YARN=''
 	gulp bundle-dts
-	make build-typescript-3.7-typings
+	make build-typescript-legacy-typings
 	sh -e debian/restore.sh
 	rm -f debian/restore.sh
 	# Build pirates
@@ -77,11 +80,11 @@
 	help2man --no-info \
 		--version-string $(DEB_VERSION_UPSTREAM) \
 		-n $(BABELJSDESC) \
-		packages/babel-cli/bin/babel.js > babeljs-7.1
+		packages/babel-cli/bin/babel.js > babeljs.1
 	help2man --no-info \
 		--version-string $(DEB_VERSION_UPSTREAM) \
 		-n $(BABELJSNODEDESC) \
-		packages/babel-node/bin/babel-node.js > babeljs-7-node.1
+		packages/babel-node/bin/babel-node.js > babeljs-node.1
 
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
 override_dh_auto_test:
@@ -91,6 +94,28 @@
 	dh_install
 	find debian -name .npmignore -delete
 	find debian -name .gitignore -delete
+	find debian -name tsconfig.tsbuildinfo -delete
+	cd debian/node-babel7 && rm -rf `cat ../../debian/node-babel7-*.install|sed 's/.* //g'`
+
+override_dh_gencontrol:
+	BABELPROVIDES=`grep -sh 'nodejs:Provides' debian/*.substvars|head -n1|sed -e 's/nodejs:Provides=//'`; \
+	set -e; \
+	for m in `cd debian && ls node-babel7-*.install`; do \
+		bundle=''; \
+		mod=$${m%.install}; \
+		for p in `cat debian/$$mod.install`; do \
+			pversion=`jq -r .version debian/$$mod/$$p/package.json` ; \
+			pname=`jq -r .name debian/$$mod/$$p/package.json` ; \
+			pname=node-`echo $$pname|sed -e 's/^.types./types-/' -e 's/.babel\//babel-/' -e 's/__/-/g'`; \
+			echo "Found $$pname ($$pversion) in $$mod"; \
+			bundle="$$pname (=$$pversion-1), $$bundle"; \
+			BABELPROVIDES=`echo $$BABELPROVIDES|sed -e "s/ *$$pname [^,]*,//g"`; \
+		done; \
+		echo dh_gencontrol -p$$mod -- -Vbabel:depsProvides="$$bundle"; \
+		dh_gencontrol -p$$mod -- -Vbabel:depsProvides="$$bundle"; \
+	done; \
+	echo "babel7 Provides value: $$BABELPROVIDES"; \
+	dh_gencontrol -pnode-babel7 -- -Vbabel:Provides="$$BABELPROVIDES"
 
 override_dh_fixperms:
 	dh_fixperms

=== debian/tests/control ===
Tests: require
Depends: node-babel7
Restrictions: superficial, allow-stderr

Depends: @, @builddeps@
Restrictions: allow-stderr
Features: test-name=rebuild-itself
Test-Command: dh_auto_configure --buildsystem=nodejs && ./debian/rules override_dh_auto_build

=== debian/watch ===
--- 
+++ 
@@ -35,7 +35,7 @@
 
 # It is not recommended use npmregistry. Please investigate more.
 # Take a look at https://wiki.debian.org/debian/watch/
-opts="searchmode=plain,ctype=nodejs,component=babelpreset-modules,pgpmode=none" \
+opts="searchmode=plain,ctype=nodejs,component=babel-preset-modules,pgpmode=none" \
  https://registry.npmjs.org/@babel/preset-modules https://registry.npmjs.org/@babel/preset-modules/-/preset-modules-([\d\.]+)@ARCHIVE_EXT@ checksum
 
 opts=\
@@ -52,9 +52,9 @@
 
 # It is not recommended use npmregistry. Please investigate more.
 # Take a look at https://wiki.debian.org/debian/watch/
-opts="searchmode=plain,ctype=nodejs,component=babelplugin-syntax-export-namespace-from,pgpmode=none" \
+opts="searchmode=plain,ctype=nodejs,component=babel-plugin-syntax-export-namespace-from,pgpmode=none" \
  https://registry.npmjs.org/@babel/plugin-syntax-export-namespace-from https://registry.npmjs.org/@babel/plugin-syntax-export-namespace-from/-/plugin-syntax-export-namespace-from-([\d\.]+)@ARCHIVE_EXT@ checksum
 
 # It is not recommended use npmregistry. Please investigate more.
 # Take a look at https://wiki.debian.org/debian/watch/
-opts="searchmode=plain,ctype=nodejs,component=babelplugin-syntax-object-rest-spread,pgpmode=none" \
+opts="searchmode=plain,ctype=nodejs,component=babel-plugin-syntax-object-rest-spread,pgpmode=none" \
